﻿using System;
using System.Collections.Generic;
using JetBrains.Annotations;
using UnityEngine;

[Serializable]
public class Cable {
    [SerializeField]
    public List<CableSegment> segments;
}

[Serializable]
public class CableSegment {
    [SerializeField]
    public GameObject go;
    //keep references to all of these, to reduce inefficient getComponent calls
    protected RollerProperties rp = null;
    protected RollerProperties linkToGO = null;
    protected RollerProperties linkToRP = null;
    protected DistanceJoint2D dist = null;

    [SerializeField] public bool useFixedAttachmentPoint = false;
    
    [SerializeField] public Vector2 attachmentPoint = new Vector2(0,0);
}